use commander_kernel::tcp::{ConnectOptions, StreamClient};
use commander_kernel::Payload;
use prost::Message;
use std::io::Cursor;
include!(concat!(env!("OUT_DIR"), "/simple_message.rs"));

fn main() {
    let connect_options = ConnectOptions::new(String::from("127.0.0.1"), 6661);
    let client = StreamClient::new(connect_options);

    let message = MessageObject {
        text: "hello from simple_client".to_string(),
    };

    let payload = Payload {
        route: String::from("route/example"),
        body: message.encode_to_vec(),
    };

    let ret = client.send_raw_bytes(payload.encode_to_vec());

    match ret {
        Ok(d) => {
            let str = String::from_utf8(d).expect("could not decode");
            println!("client got: {}", str);
        }
        Err(_) => {
            panic!("error unpacking client response")
        }
    }
}
