use commander_host::Host;
use commander_kernel::router::Action;
use commander_kernel::tcp::ConnectOptions;
use prost::Message;
use std::io::Cursor;
include!(concat!(env!("OUT_DIR"), "/simple_message.rs"));

fn main() {
    let connect_options = ConnectOptions::new(String::from("127.0.0.1"), 6661);
    let mut host = Host::new(connect_options.clone());

    let action = ExampleAction;
    host.add_action("route/example", Box::new(action));

    match host.start() {
        Ok(_) => println!("host started"),
        Err(_e) => {
            panic!("didn't start host")
        }
    }

    println!("Host started. Hit any key to stop");
    let mut buffer = String::new();
    std::io::stdin().read_line(&mut buffer);

    match host.stop() {
        Ok(_) => println!("host stopped"),
        Err(_e) => panic!("couldn't stop"),
    }
}

struct ExampleAction;

impl Action for ExampleAction {
    fn work(&self, data: &Vec<u8>) -> Vec<u8> {
        let message = MessageObject::decode(Cursor::new(&data));
        let message = message.unwrap();
        let return_string = format!("Hello from Example. Got: {}", message.text);

        return_string.as_bytes().to_vec()
    }
}
